
if (typeof(TotalQuickFilter) == "undefined")
  var TotalQuickFilter = {};

TotalQuickFilter.Preferences = {
  d: function(elementId)   { return document.getElementById(elementId); },
  get TQF()                { return Services.wm.getMostRecentWindow("mail:3pane").TotalQuickFilter; },
  get HL()                 { return Services.wm.getMostRecentWindow("mail:3pane").HiLighter; },
  get tqfPanel()           { return this.d("quickFilterPanel"); },
  get tqfPanelBox()        { return this.d("quickFilterPanelBox"); },
  get tqfTermLength()      { return this.d("quickFilterTermLength"); },
  get tqfTermLengthPref()  { return this.d(this.TQF.prefBranch + ".minTermLength"); },
  get tqfSearchDelay()     { return this.d("quickFilterSearchDelayOnIput"); },
  get tqfSearchDelayPref() { return this.d(this.TQF.prefBranch + ".searchDelayOnIput"); },
  get tqfTermsList()       { return this.d("quickFilterTermsList"); },
  get tqfForeground()      { return this.d("quickFilterForeground"); },
  get tqfBackground()      { return this.d("quickFilterBackground"); },
  get tqfNoBackground()    { return this.d("quickFilterNoBackground"); },
  get tqfFont()            { return this.d("quickFilterFont"); },
  get tqfFontSize()        { return this.d("quickFilterFontSize"); },
  get tqfBold()            { return this.d("quickFilterBold"); },
  get tqfItalic()          { return this.d("quickFilterItalic"); },
  get tqfUnderlined()      { return this.d("quickFilterUnderlined"); },
  get tqfBgMarkers()       { return this.d("quickFilterBackgroundMarkers"); },
  get tqfNoBgMarkers()     { return this.d("quickFilterNoBackgroundMarkers"); },
  get tqfBgMarkersPref()   { return this.d(this.TQF.prefBranch + ".markersBackground"); },

  onPaneLoad: function(aEvent) {
    let self = this;
self.TQF.log.debug("TotalQuickFilter.Preferences.onPaneLoad: LOAD paneDisplay.loaded:gDisplayPane.mInitialized "+
                   self.d("paneDisplay").loaded+":"+gDisplayPane.mInitialized);
    setTimeout(function() {
      let paneDisplay = self.d("paneDisplay");
      if (paneDisplay && paneDisplay.loaded && !gDisplayPane.mInitialized)
        gDisplayPane.init();
self.TQF.log.debug("TotalQuickFilter.Preferences.onPaneLoad: START paneDisplay.loaded:gDisplayPane.mInitialized "+
                   paneDisplay.loaded+":"+gDisplayPane.mInitialized);

      if (Services.prefs.getBoolPref("mail.preferences.inContent"))
        self.d("MailPreferences").classList.add("incontent");

      self.initList();
      self.tqfNoBackground.showPopup = function() {};
      self.tqfNoBgMarkers.showPopup = function() {};

      self.tqfTermLength.value = self.tqfTermLengthPref.value;
      self.tqfSearchDelay.value = self.tqfSearchDelayPref.value;
      let mp = self.d("defaultFont").firstChild.cloneNode(true);
      self.tqfFont.appendChild(mp);
      self.tqfTermsList.selectedIndex = 0;
    }, 200);
  },

  initList: function() {
    let list = this.tqfTermsList;
    let sampletext = list.getAttribute("sampletext");
    while (list.childElementCount)
      list.lastChild.remove();

this.TQF.log.debug("initList: list.id - "+list.id);
    for (let i = 0; i < this.HL.HilightTermsCount; i++) {
      let row = document.createElement("richlistitem");
      row.setAttribute("index", i);
      row.setAttribute("number", i + 1);
      row.setAttribute("text", sampletext);
      list.appendChild(row);
      row.boxObject.lastChild.setAttribute("style", this.HL.getRuleString(row, i));
this.TQF.log.debug("initList: i - "+i);
    }
  },

  onSelectTerm: function(aEvent) {
    let selItem = aEvent.target.selectedItem;
    let index = parseInt(selItem.getAttribute("index"));
    let rule = this.HL.HilightRules[index];
this.TQF.log.debug("onSelectTerm: index - "+index);
    this.tqfForeground.color = rule.fg;
    this.tqfBackground.color = rule.bg;
    let fontname = rule.f ? rule.f : this.tqfFont.getAttribute("defaultname");
    this.tqfFont.setAttribute("label", this.tqfFont.value = fontname);
    this.tqfFontSize.value = rule.s ? rule.s : 100;
    this.tqfBold.checked = rule.b;
    this.tqfItalic.checked = rule.i;
    this.tqfUnderlined.checked = rule.u;
  },

  onChange: function(aEvent) {
    let element = aEvent.target;
    let elementId = element.tagName == "menuitem" ? element.control.id :
                                                    element.id;
    let selItem = this.tqfTermsList.selectedItem;
    let index = parseInt(selItem.getAttribute("index"));
    let rules = this.HL.HilightRules;
this.TQF.log.debug("onChange: index:id - "+index+":"+elementId);
    switch (elementId) {
      case "quickFilterForeground":
        if (element.color == rules[index].fg)
          return;
        rules[index].fg = element.color;
        break;
      case "quickFilterBackground":
        if (element.color == rules[index].bg)
          return;
        rules[index].bg = element.color;
        break;
      case "quickFilterNoBackground":
        aEvent.preventDefault();
        if (element.color == rules[index].bg)
          return;
        rules[index].bg = element.color;
        this.tqfBackground.color = element.color;
        this.tqfBackground.focus();
        break;
      case "quickFilterFont":
        if (element.value == rules[index].f)
          return;
        rules[index].f = element.value;
        break;
      case "quickFilterFontSize":
        if (element.value == rules[index].s)
          return;
        rules[index].s = element.value == 100 ? "" : element.value;
        break;
      case "quickFilterBold":
        if (element.checked == rules[index].b)
          return;
        rules[index].b = element.checked;
        break;
      case "quickFilterItalic":
        if (element.checked == rules[index].i)
          return;
        rules[index].i = element.checked;
        break;
      case "quickFilterUnderlined":
        if (element.checked == rules[index].u)
          return;
        rules[index].u = element.checked;
        break;
      default:
        return;
    }

    this.HL.HilightRules = rules;
    this.HL.HilightRulesStrings[index] = null;
    let rule = this.HL.getRuleString(selItem, index);
    selItem.boxObject.lastChild.setAttribute("style", rule);
    this.tqfTermsList.ensureIndexIsVisible(index);
    this.HL.updateHilightButtons({style:true});
    this.HL.registerHilightStyles();
this.TQF.log.debug("onChange: newrule - "+rule);
  },

  onChangeMarkers: function(aEvent) {
    let element = aEvent.target;
this.TQF.log.debug("onChangeMarkers:  ");
    switch (element.id) {
      case "quickFilterBackgroundMarkers":
        if (element.color == this.tqfBgMarkersPref.value)
          return;
        break;
      case "quickFilterNoBackgroundMarkers":
        aEvent.preventDefault();
        this.HL.MarkersBackgroundPref = element.color;
        this.tqfBgMarkers.focus();
        break;
      default:
        return;
    }
    this.setMarkers(element.color);
this.TQF.log.debug("onChangeMarkers: DONE ");
  },

  setMarkers: function(aColor) {
    let color = aColor ? aColor : this.HL.MarkersBackgroundPref;
    let doc = window.opener ? window.opener.document :
                              Services.wm.getMostRecentWindow("mail:3pane").document;
    let m = doc.getElementById("tqf-terms-markers");
    (m && m.setAttribute("style", "background-color: " + color))
    m = this.HL.getContentWin();
    m = (m && m.document.getElementById("hlMarkerBox"));
    (m && m.setAttribute("style", "background-color: " + color))
  },

  restoreDefaults: function() {
    this.HL.HilightRules = null;
    this.HL.HilightRulesStrings = [];
    let sel = this.tqfTermsList.selectedIndex;
    Services.prefs.clearUserPref(this.tqfTermLengthPref.name);
    this.tqfTermLength.value = this.tqfTermLengthPref.value;
    Services.prefs.clearUserPref(this.tqfSearchDelayPref.name);
    this.tqfSearchDelay.value = this.tqfSearchDelayPref.value;
    Services.prefs.clearUserPref(this.tqfBgMarkersPref.name);
    this.initList();
    this.tqfTermsList.selectedIndex = sel;
    this.HL.updateHilightButtons({style:true});
    this.setMarkers();
    this.HL.registerHilightStyles();
  }

} // TotalQuickFilter.Preferences
